package service;

import java.util.Date;
import net.jini.core.event.*;
import java.util.Vector;
import java.rmi.RemoteException;

public class ComputerTimer implements Timer {

    private Vector listeners = new Vector();
    private int seqNum = 0;  // event sequence counter

    public ComputerTimer() {
	// There won't be any listeners so this won't do anything
	// It's just here to look consistent
	fireNotify(VALID, seqNum++);
    }

    public void setTime(Date t) {
	// void
    }

    public Date getTime() {
	return new Date();
    }

    public boolean isValidTime() {
	return true;
    }

    public EventRegistration addEventListener(RemoteEventListener listener) {
	listeners.add(listener);
	return new EventRegistration(0L, this, null, 0L);
    }

    protected void fireNotify(long eventID,
			      long seqNum) {
	RemoteEvent remoteEvent = new RemoteEvent(this, eventID, 
						  seqNum, null);
	for (int n = 0; n < listeners.size(); n++) {
	    RemoteEventListener listener = 
		(RemoteEventListener) listeners.elementAt(n);
	    try {
		listener.notify(remoteEvent);
	    } catch(UnknownEventException e) {
		// ignore
	    } catch(RemoteException e) {
		// ignore
	    }
	}
    }
}
