package ui;

import net.jini.core.entry.Entry;
import service.*;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.rmi.RemoteException;

public class UIFactoryImpl implements UIFactory, ActionListener {

    private Timer proxy;
    private JLabel label;

    public UIFactoryImpl() {
    }

    public JFrame createJFrame(Timer proxy) {
	this.proxy = proxy;

	JFrame frame = new JFrame();
	Container contentPane = frame.getContentPane();
	BorderLayout layout = new BorderLayout();
	contentPane.setLayout(new BorderLayout());

	Date now = null;
	try {
	    now = proxy.getTime();
	} catch(RemoteException e) {
	    e.printStackTrace();
	}
	label = new JLabel(now.toString());
	contentPane.add(label, BorderLayout.CENTER);

	JButton btn = new JButton("Refresh");
	contentPane.add(btn, BorderLayout.SOUTH);
	btn.addActionListener(this);
	frame.pack();
	// let the client make this visible

	return frame;
    }

    public void actionPerformed(ActionEvent e) {
	// Refresh button was clicked
	Date now = null;
	try {
	    now = proxy.getTime();
	} catch(RemoteException re) {
	    re.printStackTrace();
	    return;
	}
	label.setText(now.toString());
    }
}
